#ifndef _FLASH_H_
#define _FLASH_H_


/* We should reference to /drivers/mtd/maps/chip-board.c */

#define	MTD_BOOT                0x01
#define	MTD_KERNEL              0x02
#define	MTD_SYSTEM              0x04
#define MTD_CONFIG              0x08
#define	MTD_MAIN                (MTD_KERNEL)

#define BOOT_SIZE               0x30000
#define CONFIG_SIZE             0x10000
#define KERNEL_SIZE             0x120000
#define SYSTEM_SIZE             0x2A0000

#define FLASH_SIZE           0x00400000
#define FLASH_ADDR_BASE      0xbc400000 //after remap
#define NVRAM_SIZE           0x10000

// flash's block size
#define BLOCK_SIZE           0x10000

#define BOOT_MTD_DEV "/dev/mtd0"
#define CONF_MTD_DEV "/dev/mtd1"
#define KERN_MTD_DEV "/dev/mtd2"
#define SYST_MTD_DEV "/dev/mtd3"

enum{
    MTD_PART_BOOT = 0,
    MTD_PART_CONFIG,
    MTD_PART_KERNEL,
    MTD_PART_ROOTFS,
    PARTITION_NUM
};

#endif /* _FLASH_H_ */

