// V1000 2009-1-7 PBS
/*************************************
* 1.check the variable is valid or not
* 	blankIP(Obj)
* 	isIpStr(addr)
* 	checkIp(ip,ip,ip,ip,msg,flag)
* 	checkIpLoose(ip,ip,ip,ip,msg)
* 	checkHostIP(ip,mask)
*		checkNetMask(ip,ip,ip,ip,msg)
*
* 	netCompare(ip,mask,ip,mask)
*		ipCompare(ip,ip)
* 	cp_ip(sip,sip,sip,sip,fip,fip,fip,fip) : check finish ip is bigger than start ip or not
*		isBigger(str, str)
* 	checkIntStr(str,min,max) 			 	 			 : check the value of "string str" is between minval and maxval which are integer
*
* 	checkBlank(fieldObj, fname)
*		checkMAC(fieldObj,fmsg)
* 	validString(name)									 	 	 : used for check hostname ,domain name ,password ,login name,mail sender address
*		validssid(name)												 : this function can be used to check other string which do not allow include ssid_str ,and this str can be enlarged
*		isHex(str)
*		isIntStr(str)
* 	checkInt(text_field, name, min, max, flag) : check the value of text_input_field ia between min_value and max_value	 
*
* 	chkSelected(sel_obj, errmsg)
*		optionSelected(sel_obj)
*
* 2. get information
* 	GetNet(ip,mask)							 					 : get the network segment 
*
* 3. connection string 
*		addstr(input_msg) 									 	 : this function could have many parameters,it will piece together all the strings.
*
* 4. function control
*		 setDisabled(OnOffFlag,formFields)     : change the status of the formFields to OnOffFlag
*
*	5. deal with html page
* 	openDataSubWin(filename,win_type)		 	 : open the page of filename ,win_type is the attribute of the sub-page
*		openHelpWin(filename)
*		closeWin(win_var)
*		closeSubWins()
*		setHTML(windowObj, name, htmlStr)
*
* 6. show message
* 	showMsg()
* 	errMsg(msg)
*		show_hide(name,shownow)
* 
*************************************/

var HelpOptionsVar = "width=480,height=420,scrollbars,toolbar,resizable,dependent=yes";
var GlossOptionsVar = "width=420,height=180,scrollbars,toolbar,resizable,dependent=yes";
var bigsub   = "width=560,height=440,scrollbars,menubar,resizable,status,dependent=yes";
var hugesub   = "width=620,height=500,scrollbars,menubar,resizable,status,dependent=yes";
var smallsub = "width=440,height=320,scrollbars,resizable,status,dependent=yes";
var memsub   = "width=630,height=320,scrollbars,menubar,resizable,status,dependent=yes";
var helpWinVar = null;
var glossWinVar = null;
var datSubWinVar = null;
var DEBUG = false; // false for release
var separator = "\t";  

/*this string is used for hostname ,domain name ,password ,login name,mail sender address*/
var ValidStr = "abcdefghijklmnopqrstuvwxyz-._ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";

/*this string is used for check MAC address,hex character*/
var hex_str = "ABCDEFabcdef0123456789";

/*this string is used for check SSID */
var ssid_str = "#$&*()\"";

function setHTML(windowObj, el, htmlStr)
{
    if (document.all)
	{
	  if (windowObj.document.all(el) )
        windowObj.document.all(el).innerHTML = htmlStr;
	}
	else if (document.getElementById)
	{
	  if (windowObj.document.getElementById(el) )
	    windowObj.document.getElementById(el).innerHTML = htmlStr;
	}
}

function showMsg()
{
	if (!msgVar) return;
	
	else if (msgVar.length > 1) 
		alert(msgVar);
}

function errMsg(msg)  // return true if msg.length > 1
{
	if (msg.length > 1)
	{
		alert(msg);
		return true;
	}
	else return false;
}

function closeWin(win_var)	
{
	if   ((win_var != null) && (win_var.closed == false))
			win_var.close();
}

function openDataSubWin(filename,win_type)
{
	closeWin(datSubWinVar);
	datSubWinVar = window.open(filename,'datasub_win',win_type);
	if (datSubWinVar.focus)
		setTimeout('datSubWinVar.focus()',200);
}

function closeSubWins()
{
	closeWin(helpWinVar);
	closeWin(glossWinVar);
	closeWin(datSubWinVar);
}

function addstr(input_msg)
{
	var last_msg = "";
	var str_location;
	var temp_str_1 = "";
	var temp_str_2 = "";
	var str_num = 0;
	temp_str_1 = addstr.arguments[0];
	while(1)
	{
		str_location = temp_str_1.indexOf("%s");
		if(str_location >= 0)
		{
			str_num++;
			temp_str_2 = temp_str_1.substring(0,str_location);
			last_msg += temp_str_2 + addstr.arguments[str_num];
			temp_str_1 = temp_str_1.substring(str_location+2,temp_str_1.length);
			continue;
		}
		if(str_location < 0)
		{
			last_msg += temp_str_1;
			break;
		}
	}
	return last_msg;
}

function checkBlank(fieldObj, fname)
{
	var msg = "";
	if (fieldObj.value.length < 1)
		msg = addstr(msg_blank,fname);
	return msg;
}

function checkIsAscii(field, fname)
{
	var error_msg = "";
	var len = field.value.length;
	var str = field.value;

	error_msg += checkBlank(field, fname);
	if(error_msg.length > 1)return error_msg;

	var pattern = /^[\x20-\x7e]+$/;
	var flag = pattern.test(str);
	if(!flag)error_msg = addstr(msg_ascii, fname);

	return error_msg;
}


//checkName(cf.ssid, "SSID", "123abc_")
function checkName(field, fname, Valid_Str)
{
	var error_msg = "";
	var len = field.value.length;
	var str = field.value;
	
	if(Valid_Str.toLowerCase() == "ascii")
		return checkIsAscii(field, fname);
	
	error_msg += checkBlank(field, fname);
	if(error_msg.length > 1)return error_msg;
	
	for(var i = 0; i < len; i++)
	{
			if(Valid_Str.indexOf(str.charAt(i)) == -1)
			{
				error_msg += addstr(msg_valid_name, fname);
				break;
			}
	}
	return error_msg;
}


function checkInt(text_input_field, field_name, min_value, max_value, required)
// NOTE: Doesn't allow negative numbers, required is true/false
{
	var str = text_input_field.value;
	var error_msg= "";

	if (text_input_field.value.length==0) // blank
	{
		if (required)
			error_msg = addstr(msg_blank,field_name);
	}
	else // not blank, check contents
	{
		for (var i=0; i < str.length; i++)
		{
			if ((str.charAt(i) < '0') || (str.charAt(i) > '9'))
				error_msg = addstr(msg_check_invalid,field_name);
		}
		if (error_msg.length < 2) // don't parse if invalid
		{
			var int_value = parseInt(str,10);
			if (int_value < min_value)
				error_msg = addstr(msg_greater,field_name,(min_value - 1));
			if (int_value > max_value)
				error_msg = addstr(msg_less,field_name,(max_value + 1));
		}
	}
	return(error_msg);
}

function blankIP(fn) // true if 0 or blank
{
	return ( (fn.value == "") || (fn.value == "0") )
}

function checkIp(ip1,ip2,ip3,ip4,msg,rq_flag)
{
	var space=/ /g;

	ip1.value = ip1.value.replace(space,"");
	ip2.value = ip2.value.replace(space,"");
	ip3.value = ip3.value.replace(space,"");
	ip4.value = ip4.value.replace(space,"");

	if( (rq_flag == false) && blankIP(ip1) && blankIP(ip2) && blankIP(ip3) && blankIP(ip4) )
		return "";
	var errmsg =  checkInt(ip1,msg,1,223,true);
	errmsg =  (errmsg.length > 1) ? errmsg : checkInt(ip2,msg,0,255,true);
	errmsg =  (errmsg.length > 1) ? errmsg : checkInt(ip3,msg,0,255,true);
	errmsg =  (errmsg.length > 1) ? errmsg : checkInt(ip4,msg,1,254,true);
	errmsg =  (errmsg.length > 1) ? addstr(msg_validIP,msg) : "";
	if(errmsg.length <=1)
		if((ip1.value == 127) && (ip2.value == 0) && (ip3.value == 0) && (ip4.value == 1))
		errmsg = addstr(msg_ip_inva,msg);
	return errmsg;
}

function checkIpLoose(ip1,ip2,ip3,ip4,msg)
{
	var errmsg =  checkInt(ip1,msg,0,255,true);
	errmsg =  (errmsg.length > 1) ? errmsg : checkInt(ip2,msg,0,255,true);
	errmsg =  (errmsg.length > 1) ? errmsg : checkInt(ip3,msg,0,255,true);
	errmsg =  (errmsg.length > 1) ? errmsg : checkInt(ip4,msg,0,255,true);
	errmsg =  (errmsg.length > 1) ? errmsg : "";
	return (errmsg.length > 1)? msg:"";
}

function prefixIs1(num) // just for check mask
{
	if(num == 0)
		return 1;
	var i = 0, j = 0;
	for(; i < 8; i ++)
	{
		if((num & 0x0080) == 0)
		{
			j = 1;			
		}
		else{
				if(j == 1)
					return 0;			
		}
		num = num << 1;		
	}
	
	return 1;
}


function checkNetMask(ip1,ip2,ip3,ip4,msg)
{
	var errmsg =  checkInt(ip1,msg,0,255,true);
	errmsg =  (errmsg.length > 1) ? errmsg : checkInt(ip2,msg,0,255,true);
	errmsg =  (errmsg.length > 1) ? errmsg : checkInt(ip3,msg,0,255,true);
	errmsg =  (errmsg.length > 1) ? errmsg : checkInt(ip4,msg,0,255,true);
  if(errmsg.length > 0)return errmsg;
  
	var num1 = parseInt(ip1.value, 10);
	var num2 = parseInt(ip2.value, 10);
	var num3 = parseInt(ip3.value, 10);
	var num4 = parseInt(ip4.value, 10);
	if(num1 == 0)return msg_netmask + msg_validMask;
	if(num1 != 255)
		if(num2 + num3 + num4 != 0 || prefixIs1(num1) == 0)
			return msg_netmask + msg_validMask;				
		
	if(num2 != 255 && ((num3 + num4 != 0) || prefixIs1(num2) == 0))
			return msg_netmask + msg_validMask;			
 		
	if(num3 != 255 && ((num4 != 0) || prefixIs1(num3) == 0))
			return msg_netmask + msg_validMask;			
	
	if(prefixIs1(num4) == 0)return msg_netmask + msg_validMask;
	return "";
}

function checkNetAddr(fixip1,fixip2,fixip3,fixip4,netmask1,netmask2,netmask3,netmask4,checkip1,checkip2,checkip3,checkip4,msg,rq_flag)
{
	var space=/ /g;

	checkip1.value = checkip1.value.replace(space,"");
	checkip2.value = checkip2.value.replace(space,"");
	checkip3.value = checkip3.value.replace(space,"");
	checkip4.value = checkip4.value.replace(space,"");

	if( (rq_flag == false) && blankIP(checkip1) && blankIP(checkip2) && blankIP(checkip3) && blankIP(checkip4) )
		return "";
        var error_msg = "";
        var num1 = parseInt(fixip1.value,10);
        var num2 = parseInt(fixip2.value,10);
        var num3 = parseInt(fixip3.value,10);
        var num4 = parseInt(fixip4.value,10);
        num1 = num1 << 24;
		num1 = num1 >>> 0
		num2 = num2 << 16;
	    num3 = num3 << 8;
        var fixip = num1 + num2 + num3 + num4;
		fixip = fixip >>> 0;
        
        num1 = parseInt(netmask1.value,10);
        num2 = parseInt(netmask2.value,10);
        num3 = parseInt(netmask3.value,10);
        num4 = parseInt(netmask4.value,10);
        num1 = num1 << 24;
		num1 = num1 >>> 0;
		num2 = num2 << 16;
	    num3 = num3 << 8;
        var netmask = num1 + num2 + num3 + num4;
		netmask= netmask >>> 0;
        
        num1 = parseInt(checkip1.value,10);
        num2 = parseInt(checkip2.value,10);
        num3 = parseInt(checkip3.value,10);
        num4 = parseInt(checkip4.value,10);
        num1 = num1 << 24;
		num1 = num1 >>> 0;
		num2 = num2 << 16;
	    num3 = num3 << 8;
        var checkip = num1 + num2 + num3 + num4;
		checkip = checkip >>> 0;
		
		var fixand = fixip & netmask;
		var checkand = checkip & netmask;
        
        if(fixand == checkand)
        {
		   return "";
        }
      
		error_msg = addstr(msg_validNetAddr,msg) + "  ";
		fixand = fixand >>> 0;
                var tempAnd = 0xff000000;
                tempAnd >>> 0;
	    var tmp1;
		for (var i=0;i<4;i++)
		{
                        tmp1 =fixand & tempAnd;
			tmp1 =tmp1 >>> (24-8*i);
			if(i!=0)
			{
				error_msg += "."
			}
			if(i==3)
			{
			    error_msg += "1";
			}
			else
			{
				error_msg += tmp1.toString(10);
			}
                        tempAnd = tempAnd >>> 8;
		}
		error_msg += "  -  ";
		netmask = netmask >>> 0
		netmask = ~netmask;
		netmask = netmask & 0xfffffffe;
        var ipTop = fixand | netmask;
		ipTop = ipTop >>> 0;
                tempAnd=0xff000000;
                tempAnd = tempAnd >>> 0;
		for (i=0;i<4;i++)
		{
                        tmp1 =ipTop & tempAnd;
			tmp1 =tmp1 >>> (24-8*i);
			if(i!=0)
			{
				error_msg += "."
			}
			error_msg += tmp1.toString(10);
                        tempAnd = tempAnd >>> 8;
		}
        return error_msg;
}
function checkMAC(fieldObj,fmsg)
{
	var address = fieldObj.value;
	var myRE = /[0-9a-fA-F]{12}/;
	var newMAC = "";
	var mac = "";

	if(address.length > 11)
	{
	   newMAC = address.replace(/[:-]/g,"");
	}
		mac = newMAC.charAt(1) ;

	if ((newMAC.length != 12) || (newMAC=="000000000000") ||(mac=="1")||(mac=="3")||(mac=="5")||(mac=="7")||(mac=="9")||(mac=="b")||(mac=="d")||(mac=="f")||(myRE.test(newMAC)!=true))	
		return addstr(msg_invalidMAC,fmsg);	
	else
		return "";
}

function SternCheckMAC(fieldObj,fmsg)
{
	var address = fieldObj.value;
	var myRE = /[0-9a-fA-F]{12}/;
	var rejectee = /[13579bdfBDF]{1}/;
	var newMAC = "";
	var headMAC = "";

	if(address.length == 17)
	{
		for(i=2; i < 17; i=i+3)
		{
			if(address.charAt(i) != ':')
				return addstr(msg_SternInvalidMAC,fmsg);
		}
		newMAC = address.replace(/[:]/g,"");
	}
	else if(address.length == 12)
	{
		newMAC = address;
		fieldObj.value="";
		for(i=0,j=2; i<12; i=i+1)
		{
			if(i==j)
			{
				fieldObj.value += ":";
				j=j+2;
			}
			fieldObj.value += address.charAt(i);
		}
	}
	else
		return addstr(msg_SternInvalidMAC,fmsg);

	headMAC = newMAC.charAt(1);
	if((newMAC.length != 12) || (newMAC=="000000000000") || rejectee.test(headMAC)==true || (myRE.test(newMAC)!=true))	
		return addstr(msg_SternInvalidMAC,fmsg);	
	else
		return "";
}

function cp_ip(from1,from2,from3,from4,to1,to2,to3,to4)
//true invalid from and to ip;  false valid from and to ip;
{
    var total1 = 0;
    var total2 = 0;
    
    total1 += parseInt(from4.value,10);
    total1 += parseInt(from3.value,10)*256;
    total1 += parseInt(from2.value,10)*256*256;
    total1 += parseInt(from1.value,10)*256*256*256;
    
    total2 += parseInt(to4.value,10);
    total2 += parseInt(to3.value,10)*256;
    total2 += parseInt(to2.value,10)*256*256;
    total2 += parseInt(to1.value,10)*256*256*256;
    if(total1 > total2)
        return true;
    return false;
}

function isHex(str)
{
    var i;
    for(i = 0; i<str.length; i++) {
        var c = str.substring(i, i+1);
        if(hex_str.indexOf(c) != -1) 
        {
            continue;
        }
        return false;
    }
    return true;
}

function isBigger(str_a, str_b)
//  true if a bigger than b
{
	var int_value_a = parseInt(str_a);
	var int_value_b = parseInt(str_b);
	return (int_value_a > int_value_b);
}

function ipCmp(startip1,startip2,startip3,startip4,finiship1,finiship2,finiship3,finiship4)
//  true if startip bigger than finiship
{
    var num1 = parseInt(startip1.value,10);
    var num2 = parseInt(startip2.value,10);
    var num3 = parseInt(startip3.value,10);
    var num4 = parseInt(startip4.value,10);
    num1 = num1 << 24;
    num1 = num1 >>> 0;
    num2 = num2 << 16;
    num3 = num3 << 8;
    var startip = num1 + num2 + num3 + num4;
    startip = startip >>> 0;

    num1 = parseInt(finiship1.value,10);
    num2 = parseInt(finiship2.value,10);
    num3 = parseInt(finiship3.value,10);
    num4 = parseInt(finiship4.value,10);
    num1 = num1 << 24;
    num1 = num1 >>> 0;
    num2 = num2 << 16;
    num3 = num3 << 8;
    var finiship = num1 + num2 + num3 + num4;
    finiship = finiship >>> 0;
    return (startip > finiship);
}


function isIntStr(str) {
    var i;
    for(i = 0; i<str.length; i++) {
        var c = str.substring(i, i+1);
        if("0" <= c && c <= "9") {
            continue;
        }
        return false;
    }
    return true;
}

function checkIntStr(str,minval,maxval)
{
	if(!(isIntStr(str)))
		return false;	
	var ival = parseInt(str);
	if(ival < minval || ival > maxval)
		return false;
	else return true;
}	

function isIpStr(addrStr) 
{
    var i;
    var a = addrStr.split(".");
    if(a.length != 4) 
      return false;
    if(!checkIntStr(a[0],1,254))
			return false;
    if(!checkIntStr(a[1],0,255))
			return false;
    if(!checkIntStr(a[2],0,255))
			return false;
    if(!checkIntStr(a[3],1,254))
			return false;
    return true;
}



function show_hide(el,shownow)  // IE & NS6; shownow = true, false
{
	var showit = "block";
	var hideit = "none";

	if (document.all)
		document.all(el).style.display = (shownow) ? showit : hideit ;
	else if (document.getElementById)
		document.getElementById(el).style.display = (shownow) ? showit : hideit ;
}

function chkSelected(selObj, err_msg)
{
    if(!(selObj.selectedIndex >= 0 ))
	{
	    alert(err_msg);
	    return false;
	}
	return true;
}

function setDisabled(OnOffFlag,formFields)
{
	for (var i = 1; i < setDisabled.arguments.length; i++)
		setDisabled.arguments[i].disabled = OnOffFlag;
}

function validString(name)
{
    var localname = name.toLowerCase();
    var re = /[^\x00-\xff]/;
    re.compile("[^\x00-\xff]","i");  

    for(i=0;i<localname.length;i++)
    {
        var token=localname.charAt(i);
        if(ValidStr.indexOf(token) == -1)
            return false;
        if(re.test(token))
        	return false;
        	
    }
    
    return true;
}

function validssid(ssid_name)
{
	for(var i=0 ;i < ssid_name.length;i++)
	{
		if(ssid_str.indexOf(ssid_name.charAt(i)) != -1)
			return (msg_invalid_ssid);
	}
	return "";
}

function ipCompare(ip1,ip2)
{
  var ip_1=ip1.split(".");
  var ip_2=ip2.split(".");
  var i;
  for(i=0;i<4;i++)
  {
    if(parseInt(ip_1[i]) > parseInt(ip_2[i]))
      return 1;

    if(parseInt(ip_1[i]) < parseInt(ip_2[i]))
      return -1;
  }
  return 0;
}
function GetNet(ip_str,mask_str)
{
  var ip = ip_str.split(".");
  var mask = mask_str.split(".");
  var ip_i = new Array(0,0,0,0);
  var mask_i = new Array(255,255,255,255);
  var net_i = new Array(255,255,255,255);
  var broad_i = new Array(255,255,255,255);
  var tmp = "",host_str="",net_str="",check = '0';

  for(i=0;i<4;i++)
  {
   ip_i[i] = parseInt(ip[i]);
   mask_i[i] = parseInt(mask[i]);
   net_i[i] = ip_i[i] & mask_i[i];
   if(mask_i[i] < 255)
   {
    broad_i[i] = 255-mask_i[i];
   }
   else
   {
     broad_i[i] = net_i[i];
   }
   tmp += mask_i[i].toString(2);
   if(host_str != "")
   {
     host_str += ".";
     net_str += ".";
   }
   host_str += broad_i[i].toString();
   net_str += net_i[i].toString();
  }
  return net_str;
}
function netCompare(ip1,mask1,ip2,mask2)
{
  var net1=GetNet(ip1,mask1);
  var net2=GetNet(ip2,mask2);
  return ipCompare(net1,net2);
}
function checkHostIP(ip_str,mask_str)
{
  var ip = ip_str.split(".");
  var mask = mask_str.split(".");
  var ip_i = new Array(0,0,0,0);
  var mask_i = new Array(255,255,255,255);
  var net_i = new Array(255,255,255,255);
  var broad_i = new Array(255,255,255,255);
  var tmp = "",host_str="",net_str="",check = '0';

  for(i=0;i<4;i++)
  {
   ip_i[i] = parseInt(ip[i]);
   mask_i[i] = parseInt(mask[i]);
   net_i[i] = ip_i[i] & mask_i[i];
   if(mask_i[i] < 255)
   {
    broad_i[i] = 255-mask_i[i] + net_i[i];
   }
   else
   {
     broad_i[i] = net_i[i];
   }
   tmp += mask_i[i].toString(2);
   if(host_str != "")
   {
     host_str += ".";
     net_str += ".";
   }
   host_str += broad_i[i].toString();
   net_str += net_i[i].toString();
  }

  for(i=31;i>=0;i--)
  {
    if(check == '0' && tmp.charAt(i) == '1')
      check = '1';
    if(check == '1' && tmp.charAt(i) == '0')
    {
        alert(msg_mask_error);
        return false;
    }
  }
  
  if(ipCompare(ip_str,net_str)<=0 || ipCompare(ip_str,host_str)>=0 )  
  {
    alert("[" + ip_str + "]" + msg_host_ip_error);
    return false;
  }
  return true;
}

function optionSelected(sel_obj) //Data Transfer Functions return ,true or false
{
	return (sel_obj.selectedIndex > -1 && sel_obj.selectedIndex < sel_obj.options.length) ? true : false;
}


function changeRowCr(idtbl)
{
	var idd = document.getElementById(idtbl);
	if (idd == null) return;
	var cnt = idd.rows.length;
	var n = 0;
	for (var i = 0; i < cnt; i++) {
		if (idd.rows[i].style.display != "none") {
			for (var j = 0; j < idd.rows[i].cells.length; j++) {
				idd.rows[i].cells[j].style.backgroundColor = ((n % 2) == 1) ? "#E6E6E6" : "#FFFFFF";
			}
			n++;
		}
	}
}

function groupHead(tit,ids,w)
{
	document.write('<table class="sframe" cellspacing="0" cellpadding="0" width="'+w+'" align="center">');
	document.write('<tr><td class="sframe_title headline"><img src="dot5s.gif" width="11" height="11">'+tit+'<\/td><\/tr>');

	document.write('<tr><td class="sframe">');
	document.write('<table class="cfgframe" id="'+ids+'" cellspacing="2" cellpadding="0" width="100%" align="center">');
}


function groupTail()
{
	document.write('<\/table><\/td><\/tr><\/table>');
}

function btnHead(w)
{
	document.write('<table class="sframe" cellspacing="0" cellpadding="0" width="'+w+'" align="center">');
	document.write('<tr><td class="sframe">');
	document.write('<table class="cfgframe" id="button" cellspacing="2" cellpadding="0" width="100%" align="center">');
}
function btnTail()
{
	document.write('<\/table><\/td><\/tr><\/table>');
}

function setValue(el, htmlStr)
{
	if (document.all)
	{
	  if (document.all(el))
	  {
	  	document.all(el).innerHTML = htmlStr;
    }
	}
	else if (document.getElementById)
	{
	  if (document.getElementById(el) )
	    document.getElementById(el).innerHTML = htmlStr;
	}
}
